;#########################################################################
;		Compiler directives

	.686
	.MMX
	.XMM
	.model flat, stdcall  ;32 bit memory model
	option casemap :none  ;case sensitive

	

Comment /*

This is a comment block
Everything here is a comment

*/

;#########################################################################
;		Include files

	include ListView.inc
	

;#########################################################################

.data
	tvi TV_INSERTSTRUCT <0>
	hello dd 0

.code

start:
	invoke GetModuleHandle,NULL
	mov hInstance,eax

	mov icc.dwSize,SIZE INITCOMMONCONTROLSEX
	mov icc.dwICC,65535
	invoke InitCommonControlsEx,ADDR icc
	
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;#########################################################################

DlgProc proc uses ebx esi edi hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov eax,uMsg
	.IF eax == WM_INITDIALOG
		mov eax,hWin
		mov hDlg,eax
		invoke GetDlgItem,hDlg,1001
		mov hListView,eax
		invoke SetUpListView
		invoke LVAddItem,0,OFFSET szColumn0,OFFSET szColumn1,OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,OFFSET szColumn0,OFFSET szColumn1,OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,OFFSET szColumn0,OFFSET szColumn1,OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,OFFSET szColumn0,OFFSET szColumn1,OFFSET szColumn2,OFFSET szColumn3


	.ELSEIF eax == WM_COMMAND
		mov eax,wParam
		mov dx,ax
		mov eax, wParam
		shr eax, 16
		.IF eax == BN_DBLCLK
			PrintText "BN_DBLCLK"

		.ENDIF

	.ELSEIF eax == WM_LBUTTONDBLCLK
		PrintText "WM_LBUTTONDBLCLK"

	.ELSEIF eax == WM_CLOSE
		invoke EndDialog,hWin,0

	.ELSE
		mov eax,FALSE
		ret

	.ENDIF

	mov eax,TRUE
	ret

DlgProc endp

; The listview stuff
SetUpListView proc
	LOCAL LVColumn		:LV_COLUMN

	invoke ImageList_Create,16,16,ILC_MASK or ILC_COLOR24,1,10
	mov hIml,eax
	invoke LoadIcon,hInstance,10000
	mov hIcon1,eax
	invoke ImageList_AddIcon,hIml,eax
	invoke LoadIcon,hInstance,10001
	mov hIcon2,eax
	invoke ImageList_AddIcon,hIml,eax

	invoke DestroyIcon,hIcon1
	invoke DestroyIcon,hIcon2

	invoke SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,hIml

	mov LVColumn.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
	mov LVColumn.fmt,LVCFMT_LEFT
	mov LVColumn.lx,45
	mov LVColumn.pszText,OFFSET szColumn0
	mov LVColumn.cchTextMax,SIZEOF szColumn0
	invoke SendMessage,hListView,LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov LVColumn.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
	mov LVColumn.fmt,LVCFMT_LEFT
	mov LVColumn.lx,75
	mov LVColumn.pszText,OFFSET szColumn1
	mov LVColumn.cchTextMax,SIZEOF szColumn1
	invoke SendMessage,hListView,LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov LVColumn.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH or LVCF_SUBITEM
	mov LVColumn.fmt,LVCFMT_LEFT
	mov LVColumn.lx,100
	mov LVColumn.pszText,OFFSET szColumn2
	mov LVColumn.cchTextMax,SIZEOF szColumn2
	mov LVColumn.iSubItem,1
	invoke SendMessage,hListView,LVM_INSERTCOLUMN,2,ADDR LVColumn

	mov LVColumn.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH or LVCF_SUBITEM
	mov LVColumn.fmt,LVCFMT_LEFT
	mov LVColumn.lx,330
	mov LVColumn.pszText,OFFSET szColumn3
	mov LVColumn.cchTextMax,SIZEOF szColumn3
	mov LVColumn.iSubItem,2
	invoke SendMessage,hListView,LVM_INSERTCOLUMN,3,ADDR LVColumn

	invoke SendMessage,hListView,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT

	ret
SetUpListView endp

LVAddItem proc Image:DWORD,Col0:DWORD,Col1:DWORD,Col2:DWORD,Col3:DWORD
	LOCAL LVItem		:LV_ITEM
	LOCAL szItemID[16]	:BYTE
	LOCAL ItemID		:DWORD

	invoke SendMessage,hListView,LVM_GETITEMCOUNT,0,0
	mov ItemID,eax

	mov LVItem.imask,LVIF_PARAM or LVIF_TEXT or LVIF_IMAGE
	mov LVItem.iSubItem,0
	mov eax,Col0
	mov LVItem.pszText,eax

	mov eax,Image
	mov LVItem.iImage,eax
	mov eax,ItemID
	mov LVItem.iItem,eax
	mov LVItem.lParam,FALSE
	invoke SendMessage,hListView,LVM_INSERTITEM,0,ADDR LVItem
	mov ItemID,eax

	mov eax,Col1
	mov LVItem.pszText,eax
	mov eax,ItemID
	mov LVItem.iItem,eax
	mov LVItem.iSubItem,1
	mov LVItem.imask,LVIF_TEXT
	invoke SendMessage,hListView,LVM_SETITEM,0,ADDR LVItem

	mov eax,Col2
	mov LVItem.pszText,eax
	mov eax,ItemID
	mov LVItem.iItem,eax
	mov LVItem.iSubItem,2
	mov LVItem.imask,LVIF_TEXT
	invoke SendMessage,hListView,LVM_SETITEM,0,ADDR LVItem
	

	mov eax,Col3
	mov LVItem.pszText,eax
	mov eax,ItemID
	mov LVItem.iItem,eax
	mov LVItem.iSubItem,3
	mov LVItem.imask,LVIF_TEXT
	invoke SendMessage,hListView,LVM_SETITEM,0,ADDR LVItem

	mov eax,ItemID
	ret
LVAddItem endp

end start
